package com.jz.agent.client;


import com.jz.agent.client.service.*;
import com.jz.dmp.modules.model.DmpAgentDatasourceInfo;

public class DmpDsAgentClientBuilder {

    public static DmpDsAgentClient build(DmpAgentDatasourceInfo ds) {
        switch (ds.getDatasourceType()) {
            case "MYSQL":
                return new DmpMysqlAgentClientService();
            case "SQLSERVER":
                return new DmpSqlServerAgentClientService();
            case "POSTGRESQL":
                return new DmpPostgreSqlAgentClientService();
            case "ORACLE":
                return new DmpOracleAgentClientService();
            case "DM":
                return null;
            case "DB2":
                return new DmpDB2AgentClientService();
            case "HIVE":
                return new DmpHiveAgentClientService();
            case "IMPALA":
                return null;
            case "KUDU":
                return new DmpKuduAgentClientService();
            // return SpringUtils.getBean(DmpKuduAgentClientService.class);
            case "HDFS":
                return new DmpHdfsAgentClientService();
            case "FTP":
                return new DmpFtpAgentClientService();
            case "ELASTICSEARCH":
                return new DmpElasticsearchAgentClientService();
            case "MONGODB":
                return null;
            case "MEMCACHE":
                return null;
            case "REDIS":
                return null;
            case "HBASE":
                return null;
            case "LOGHUB":
                return null;
            case "KAFKA":
                return null;
            case "ROCKETMQ":
                return null;
            case "DEFAULT":
                return new DmpHiveAgentClientService();
            default:
                break;
        }
        return null;
    }

}
