package com.jz.agent.utils;

import java.sql.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class DbInfoUtil {
	
	@SuppressWarnings({ "unused", "rawtypes" })
	public static void main(String[] args) {
		
		
		
		
		
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static List getTableInfo(String driver, String url, String user, String pwd, String table) {
		List result = new ArrayList();
		Connection conn = null;
		DatabaseMetaData dbmd = null;
		try {
			conn = JDBCUtils.getConnections(driver, url, user, pwd);
			dbmd = conn.getMetaData();
			ResultSet resultSet = dbmd.getTables(null, "%", table, new String[] { "TABLE" });
			while (resultSet.next()) {
				String tableName = resultSet.getString("TABLE_NAME");
				//System.out.println(tableName);

				if (tableName.equals(table)) {
					ResultSet rs = conn.getMetaData().getColumns(null, getSchema(conn), tableName.toUpperCase(), "%");
					while (rs.next()) {
						Map map = new HashMap();
						String colName = rs.getString("COLUMN_NAME");
						String dbType = rs.getString("TYPE_NAME");
						String remarks = rs.getString("REMARKS");
						Integer columnSize = rs.getInt("COLUMN_SIZE");
						Integer dicimalDigits = rs.getInt("DECIMAL_DIGITS");
						/*map.put("code", colName);
						if (remarks == null || remarks.equals("")) {
							remarks = colName;
						}
						map.put("name", remarks);
						map.put("dbType", dbType);
						map.put("valueType", changeDbType(dbType));
						*/
						map.put("name", colName.toLowerCase());
						map.put("type", dbType);
						map.put("size", columnSize);
						map.put("scale", dicimalDigits);
						map.put("comment", remarks);
						result.add(map);
					}
				}
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			try {
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return result;
	}

	@SuppressWarnings("unused")
	private static String changeDbType(String dbType) {
		dbType = dbType.toUpperCase();
		switch (dbType) {
		case "VARCHAR":
		case "VARCHAR2":
		case "CHAR":
			return "1";
		case "NUMBER":
		case "DECIMAL":
			return "4";
		case "INT":
		case "SMALLINT":
		case "INTEGER":
			return "2";
		case "BIGINT":
			return "6";
		case "DATETIME":
		case "TIMESTAMP":
		case "DATE":
			return "7";
		default:
			return "1";
		}
	}

	private static String getSchema(Connection conn) throws Exception {
		String schema;
		schema = conn.getMetaData().getUserName();
		if ((schema == null) || (schema.length() == 0)) {
			throw new Exception("ORACLE数据库模式不允许为空");
		}
		return schema.toUpperCase().toString();
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static List<String> getTableNameList(String driver, String url, String user, String pwd) {
		List result = new ArrayList();
		Connection conn = null;
		DatabaseMetaData dbmd = null;
		try {
			conn = JDBCUtils.getConnections(driver, url, user, pwd);
			String catalog = conn.getCatalog();
			dbmd = conn.getMetaData();
			ResultSet tablesResultSet = dbmd.getTables(catalog, null, null, new String[] { "TABLE" });
			while (tablesResultSet.next()) {
				String tableName = tablesResultSet.getString("TABLE_NAME");
				result.add(tableName.toLowerCase());
			}
		} catch (SQLException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			try {
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return result;
	}
	
	@SuppressWarnings({ "rawtypes", "unchecked" })
	public static Map getTableLimitData(String driver, String url, String user, String pwd, String table) {
		Map map = new HashMap<String, Object>();
		Connection conn = null;
		DatabaseMetaData dbmd = null;
		try {
			conn = JDBCUtils.getConnections(driver, url, user, pwd);
			String sql = "select * from " + table + " limit 5";
			dbmd = conn.getMetaData();
			ResultSet resultSet = dbmd.getTables(null, "%", table, new String[] { "TABLE" });
			List<String> headerList = new ArrayList<String>();
			List<String> typeList = new ArrayList<String>();
			while (resultSet.next()) {
				String tableName = resultSet.getString("TABLE_NAME");
				if (tableName.equals(table)) {
					ResultSet rs = conn.getMetaData().getColumns(null, getSchema(conn), tableName.toUpperCase(), "%");
					while (rs.next()) {
						String colName = rs.getString("COLUMN_NAME");
						headerList.add(colName);
						String dbType = rs.getString("TYPE_NAME");
						typeList.add(dbType);
					}
					break;
				}
			}
			map.put("header", headerList);
			PreparedStatement ps = conn.prepareStatement(sql);
			ResultSet rs = ps.executeQuery();
			List<List<Object>> resultList = new ArrayList<List<Object>>();
            while (rs.next()) {
            	List<Object> row = new ArrayList<Object>();
            	for(int i = 1; i <= headerList.size(); i++) {
            		row.add(rs.getObject(i));
            	}
            	resultList.add(row);
            }
            map.put("result", resultList);
		} catch (SQLException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			try {
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return map;
	}

}
