package com.jz.dmp.modules.dao;

import com.jz.dmp.modules.model.DmpSyncingDatasourceType;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 数据源类型(DmpSyncingDatasourceType)表数据库访问层
 *
 * @author Bellamy
 * @since 2020-12-29 19:24:05
 */
public interface DmpSyncingDatasourceTypeDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    DmpSyncingDatasourceType queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param offset 查询起始位置
     * @param limit  查询条数
     * @return 对象列表
     */
    List<DmpSyncingDatasourceType> queryAllByLimit(@Param("offset") int offset, @Param("limit") int limit);


    /**
     * 通过实体作为筛选条件查询
     *
     * @param dmpSyncingDatasourceType 实例对象
     * @return 对象列表
     */
    List<DmpSyncingDatasourceType> queryAll(DmpSyncingDatasourceType dmpSyncingDatasourceType);

    /**
     * 新增数据
     *
     * @param dmpSyncingDatasourceType 实例对象
     * @return 影响行数
     */
    int insert(DmpSyncingDatasourceType dmpSyncingDatasourceType);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<DmpSyncingDatasourceType> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<DmpSyncingDatasourceType> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<DmpSyncingDatasourceType> 实例对象列表
     * @return 影响行数
     */
    int insertOrUpdateBatch(@Param("entities") List<DmpSyncingDatasourceType> entities);

    /**
     * 修改数据
     *
     * @param dmpSyncingDatasourceType 实例对象
     * @return 影响行数
     */
    int update(DmpSyncingDatasourceType dmpSyncingDatasourceType);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    List<DmpSyncingDatasourceType> queryAllByParams(Map params) throws Exception;
}